=== debian/changelog ===
armnn (19.11.1-1) unstable; urgency=medium

  [ Francis Murtagh ]
  * Initial release of ArmNN core. (Closes: #952640)

 -- Wookey <wookey@debian.org>  Thu, 23 Apr 2020 16:18:33 +0100
