=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1


# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


# Neon always available on arm64, not armcomputelib on non-arm arches
ifeq ($(DEB_HOST_ARCH),arm64)
OPTS+=-DARMCOMPUTENEON=1 -DARMCOMPUTECL=1 -DARMCOMPUTE_LIBRARIES='arm_compute;arm_compute_core'
endif
ifeq ($(DEB_HOST_ARCH),armhf)
OPTS+=-DARMCOMPUTECL=1 -DARMCOMPUTE_LIBRARIES='arm_compute;arm_compute_core'
endif

#skip tests if requested - dh does this for us now?
#ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
#RUNTESTS=yes
#else
#RUNTESTS=""
#endif



%:
	dh $@ --buildsystem=cmake --builddirectory=build-area

override_dh_auto_configure:
	dh_auto_configure -- $(OPTS) -DBUILD_TESTS=1 -DSHARED_BOOST=ON -DARMNNREF=1 -DBUILD_ARMNN_SERIALIZER=1

override_dh_auto_test:
	./build-area/UnitTests  --run_test=!Compute_ArmComputeCl:!MemCopyClNeon:!CreateWorkloadCl:!ClEndToEnd:!ClLayerSupport:!ClOptimizedNetwork:!ClJsonPrinter:!ClRuntime:!Fp16Support:!OpenClTimerBatchNorm:!ClMemCopy
